// -*- C++ -*-

// tclDecimPipe.cc
//
// tcl interface to the objects in DecimPipe.cc
//
// for aprl - audio pattern recognition language
//  dpwe, eds@media.mit.edu 9 Feb 1995

#include <stdio.h>
#include <assert.h>
#include "DecimPipe.h"

// ----------------------- TEMPLATE DECLARATION OF DECIMPIPE --------------

#define OBJECT		DecimPipe
#define TCLNAME		decimer
#define ISPIPE
#define STRUCTFIELDS		\
    int	factor;	
#define CONFIGLINES		\
    CONFIGLINE(TK_CONFIG_INT, factor, Factor, "1")
#define COMMANDCODE(interp,ptr,c,argc,argv,length)
#define COMMANDLIST	
#define CONSTRUCTCODE(PTR, IN)	\
    PTR->obj = new DecimPipe(PTR->factor, IN);
#define CONFIGCODE(PTR)		\
    /* reconfiguration of DecimPipe not (yet) supported */

#include "tclTemplate.h"

// ----------------------- TEMPLATE DECLARATION OF LINTERPPIPE --------------

#define OBJECT		LinterpPipe
#define TCLNAME		linterper
#define ISPIPE
#define STRUCTFIELDS		\
    int	factor;	
#define CONFIGLINES		\
    CONFIGLINE(TK_CONFIG_INT, factor, Factor, "1")
#define COMMANDCODE(interp,ptr,c,argc,argv,length)
#define COMMANDLIST	
#define CONSTRUCTCODE(PTR, IN)	\
    PTR->obj = new LinterpPipe(PTR->factor, IN);
#define CONFIGCODE(PTR)		\
    /* reconfiguration of LinterpPipe not (yet) supported */

#include "tclTemplate.h"

