. $Header: /u/drspeech/src/audio_frontend/RCS/audio_frontend.man,v 1.15 1999/10/08 00:45:38 dpwe Exp $
.de PN
.ie t \&\f(CB\\$1\f(NR\\$2
.el \fI\\$1\fP\\$2
..
.de MS
.ie t \&\f(CB\\$1\f(NR(\\$2)\\$3
.el \fI\\$1\fP(\\$2)\\$3
..
.de EX		\" Begin Example
.ie \\n(.$ .nr EX \\$1n
.el \{\
.	ie n .nr EX 0n
.	el .nr EX 0n
.\}
.in +\\n(EXu
.if n .sp 1
.if t .sp .5v
.nf
.CW
.ft CB
..
.de EE		\" End example
.in -\\n(EXu
.fi
.}f             \" restore basic text attributes
.if n .sp 1
.if t .sp .5v
..
.TH AUDIO_FRONTEND 1 "$Date: 1999/10/08 00:45:38 $" ICSI "ICSI SPEECH SOFTWARE"
.SH NAME
audio_frontend, send_afe_msg \- graphical front-end for capturing live speech input and associated message passing.
.SH SYNOPSIS
\fBaudio_frontend 
[featureprog=\fIfeature-program\fB]
[featureargs=\fIfeature-program-arguments\fB]
[onlineprog=\fIonline-conversion-program\fB]
[onlineargs=\fIonline-conversion-program-arguments\fB]
[fwpprog=\fIforward-pass-program\fB]
[fwpargs=\fIforward-pass-program-arguments\fB]
[samplerate=\fIrate\fB]
[hithresh=\fIthreshold\fB]
[minRecordTime=\fItime\fB]
[playcmd=\fIcmd\fB]
[resultport=\fIport\fB]
[useloadsave=\fI{0|1}\fB]
[outputfmt=\fIfmt\fB]
| 
.I rest of processing chain
.P
\fBsend_afe_msg
[resultport=\fIport\fB]
[message=\fImsg\fB]
[wait=\fI{0|1}\fB]
[echo=\fI{0|1}\fB]
.SH DESCRIPTION
.PN audio_frontend
is a Tcl/Tk script that allows interactive input of speech for live 
demos.  It presents a panel of buttons which permit the recording and 
replay of speech, as well as the configuration of which subsequent 
programs to pass the speech data through (such as 
.MS rasta 1
and 
.MS raw2onl 1
).  
.P
The program is idle until the "Record speech" button is clicked, 
whereupon it enters "listening" mode, waiting for a signal exceeding 
its internal threshold at the audio input.  When such a signal is 
detected, the program goes into "recording" mode, which continues until 
a smoothed measure of the input energy has fallen below a second threshold, 
indicating a long-ish gap in the input speech.  This soundfile is then 
saved, and piped to the output, through any specified post-processing.
.P
Interactive control is made easy by an animated VU meter showing the 
microphone input level, and colored prompts indicating when the 
program is recording 'live' speech, and when it is idle.
.P
.PN send_afe_msg
is used as a simple way to send "result" messages to a running 
.PN audio_frontend
process.  By specifying the same "resultport" argument to both 
.PN audio_frontend
and a subsequent invocation of 
.PN send_afe_msg ,
they will communicate over the named TCP port, and the "message" 
argument to 
.PN send_afe_msg 
will be displayed in a "result" panel in the 
.PN audio_frontend
window.  Running 
.PN send_afe_msg 
without a "message" argument starts it in 'listener' mode, whereby 
it will take input from standard input by line, then copy each line to 
the
.PN audio_frontend
process.
.SH OPTIONS
The post-processing programs may be specified in the command line as show 
in the synopsis.  By default, there is no post-processing, and the output 
is headerless, 16-bit, 16 kHz-sampled audio data in the "Abbot online" 
format i.e. negative peaks are clipped at 0x8001, and a single sample 
of 0x8000 marks the end of the utterance (see \fBoutputfmt=\fR).
.TP 12
\fBhithresh=\fIthreshold\fR
Sets the threshold, in dB, above the noise floor that marks the start of an 
utterance.  Default value is 15.0.
.TP 12
\fBminRecordTime=\fItime\fR
Sets the duration, in seconds, of the shortest utterance that will be 
passed on to subsequent processing.  Detected energy shorter than this 
will be discarded.  Default value is 1.2.
.TP 12
\fBplaycmd=\fIcmd\fR
Specify a program to invoke to playback the recorded files.  If this is
omitted or specified as an empty string, playback will be accomplished 
within APRL.  This doesn't work so great on some older OSs, so specifying 
a different program that will be invoked "playcmd file.aif" here will 
use this form of playback.  The command must be specified by a full 
path (i.e. starting with "/"), since its existence will be checked at 
startup, ignoring the current path.  As a special case, specifying "playcmd=1" 
will use the default play command for AIFF files, 
.MS sndplay 1 .
.TP 12
\fBresultport=\fIport\fR
If resultport is defined, 
.PN audio_frontend 
displays a "result" panel, and then sets up a server on the TCP port 
of that number (must be above 1024 for unprivileged processes).  
Connections to this port will have a single line of text read from 
them, which will be displayed in this panel.  Normally, these connections 
would come from 
.PN send_afe_msg
.TP 12
\fBuseloadsave=\fI{0|1}\fR
If 1, extra buttons are displayed for "Load speech", "Save speech" 
and "Resubmit speech".  The "Save" button will allow the most recently 
recorded speech file to be saved to a permanent file (through a dialog 
box).  Currently, speech is saved as raw data.  The "Load" button will 
allow a previously-saved speech file to be read into the 'current' 
buffer, whereupon it may be played with the "Play speech" button.  
The "Resubmit" button allows the 'current' buffer to 
be passed on to subsequent processing.  Subsequent processing is 
invoked automatically after a successful recording, but this button 
permits the file to be submitted a second time, and allows 
the processing of files that have been loaded rather than recorded.
.TP 12
\fBfeatureprog=\fIprog \fBfeatureargs=\fIargs
.TP 12
\fBonlineprog=\fIprog \fBonlineargs=\fIargs
.TP 12
\fBfwpprog=\fIprog \fBfwpargs=\fIargs
Specify a series of programs and their arguments to be run on the output 
speech signal.  When a complete utterance is captured, it is fed, as a 
raw 16-bit binary stream, to a new invocation of:
.EX
| $featureprog $featureargs | $onlineprog $onlineargs | $fwpprog $fwpargs
.EE
If any of the "progs" arguments are empty, it is omitted from the chain.
The output of the chain goes to the standard output of the process
(but see EMBEDDING below).
.TP 12
\fBoutputfmt=\fIfmtspec\fR
Determines the format of the sound data piped to the command chain (or 
directly to standard output, if no other programs are specified).  
This must be a token recognized by the "-T" flag of 
.MS sndrfmt 1
and defaults to "PCM/Abb" for Abbot-online format raw short samples.
.P
The following are the options for 
.PN send_afe_msg :
.TP 12
\fBresultport=\fIport\fR (7777)
Which TCP port number to use to communicate with the 
.PN audio_frontend
process (i.e. the same argument as was passed to 
.PN audio_frontend ; 
must be > 1024 for user-level invocation).  If the server 
process has not yet started up, 
.PN send_afe_msg
will fail - use the "wait" option.
.TP 12
\fBmessage=\fImsg\fR
A single message to send.  After sending the message, 
.PN send_afe_msg
will exit.  However, if this option is not specified, 
the program will instead take its messages from standard input, 
and will continue sending them, line by line, until EOF.
Note: the indirection through a shell script makes it impossible 
to embed spaces in message.  As a compromise, any unescaped 
ampersands ("&") in message will be converted to spaces before 
being sent to 
.PN audio_frontend . 
(Use "\\&" to insert an ampersand).
.TP 12
\fBwait={0|1} (0)
If 0, the program will exit with an error immediately if there 
is no server listening on the specified port.  If 1, the program 
will ignore "connection refused" errors, and keep polling to 
allow an 
.PN audio_frontend
server process to start up.
.TP 12
\fBecho={0|1} (0)
If 1, when  
.PN send_afe_msg
reads a line from standard input, it will echo it to standard 
output as well as sending it to the 
.PN audio_frontend
process.  This allows it to be transparently inserted into 
a message chain.
.SH EMBEDDING
The 
.PN audio_frontend
script may be included as part of a larger Tcl/Tk application.
If the variable $afe_root is defined on entry, then all the 
.PN audio_frontend
widgets are created as descendents of this widget (e.g. to embed 
in a larger display).
.P
If the variable $afe_outputHandler is set, the output of the processing 
chain (by default, the raw binary speech stream) is not fed to stdout, 
but os created as a Tcl pipe with a "fileevent" that 
executes "$afe_outputHandler \fIpipeName\fR" whenever the pipe has data to 
be read.  This allows an enclosing program to redirect the speech 
output back into itself.

.SH ENVIRONMENT
This version of 
.PN audio_frontend
relies on the 
.PN APRL
package of audio-processing extensions for Tcl/Tk.
The package will be searched for in $DRSPEECH_LIBRARY_PATH, 
the default package path, and possibly another directory 
specified by "./configure --with-aprl=DIR".
It also calls the 
.MS sndrfmt 1
program from the dpwelib/sndutils package to filter its 
audio streams, which should be locatable in the $DRSPEECH_PATH
(the same place that 
.MS sndplay 1
will be searched for if default external playing is selected).
The scripts also rely on the specially-configured Tcl/Tk shells, 
.PN drspeech_wish
and
.PN drspeech_tclsh
which should have been generated by the \f4tclsh-readline\f1 
package (available at \f4ftp://ftp.icsi.berkeley.edu/pub/real/dpwe\f1).

.SH EXAMPLE
.EX
audio_frontend 
	featureprog=$SPEECH_BINDIR/rasta 
	featureargs="-O -S 16000 -m 12 -n 13 -L -F" 
	onlineprog=$SPEECH_BINDIR/raw2onlftr 
	onlineargs="width=13 size=4" 
| $SPEECH_BINDIR/calc_deltas -c 9 -n 13 -l -d -b 
| $SPEECH_BINDIR/swbforward ftr1_file=- ftr1_format=onlftr ...
.EE

.SH FILES
.TP 20
.IB /tmp/frontend.speech.$$.aif
Temporary AIFF file containing 16-bit speech as recorded.
.TP 20
.IB /usr/local/lib/drspeech_tcl/*.tcl
The programs are actually shell-scripts that set up the path 
then run the drspeech tcl shells on the tcl source files 
which are installed into this directory.

.SH BUGS
Interactive modification of the settings such as the featureprog 
and onlineprog is not (yet) implemented. 
.P
The very simple noise-floor estimation and energy-threshold triggering 
is sometimes confused.  However, manually aborting a record session by 
clicking the "stop recording" button forces a recalibration.  In very 
poor signal-to-noise ratio conditions, it may be necessary to reduce 
the 
.I hithresh .

.SH AUTHOR
Dan Ellis <dpwe@ICSI.Berkeley.EDU>
.br
original version by Eric Fosler <fosler@ICSI.Berkeley.EDU>
.SH NOTES
Manual page prepared by Dan Ellis <dpwe@ICSI.Berkeley.EDU> \-
corrections gratefully accepted.

