// $Header: /n/yam/da/dpwe/tmp/bedk_frontend/RCS/Matrix.h,v 1.7.1.1 1997/12/12 21:07:47 bedk Exp dpwe $
//
// Simple matrix class
//
//

#ifndef Matrix_h_INCLUDED
#define Matrix_h_INCLUDED

#include <stdlib.h>

// Handy place to put this?
#ifndef HAVE_BOOL
#ifndef BOOL_DEFINED
enum bool { false = 0, true = 1 };
#define BOOL_DEFINED
#endif
#endif /* !HAVE_BOOL */

// forward declarations
//
class Matrix;
class CMatrix;

class Matrix {
public:
  const size_t m;               // number of rows
  const size_t n;               // number of columns
  const size_t s;               // number of elements between rows
  float* const data;

  Matrix(const size_t row,
         const size_t col)
    : m(row), n(col), s(col), data(new float[row * col]) {}

  Matrix(const size_t row,
         const size_t col,
         const size_t stride)
    : m(row), n(col), s(stride), data(new float[row * stride]) {}

  ~Matrix() {delete [] data;}
};

class CMatrix {
public:
  const size_t m;               // number of rows
  const size_t n;               // number of columns
  const size_t s;               // number of elements between rows
  const float* const data;

  CMatrix(const Matrix& M)
    : m(M.m), n(M.n), s(M.s), data(M.data) {}

  CMatrix(const size_t col, const Matrix& M)
    : m(M.m), n(col), s(M.s), data(M.data) {}
  
  CMatrix(const size_t rows, const size_t cols, 
	  const size_t stride, const float* const d) 
    : m(rows), n(cols), s(stride), data(d)
    {}

  CMatrix(const size_t rows, const size_t cols, 
	  const float* const d) 
    : m(rows), n(cols), s(cols), data(d)
    {}

  ~CMatrix() {}                 // only real matrices delete data
};

#endif // Matrix_h_INCLUDED
