#include "disk.h"       /* sometimes need diskio */

/* header file for matrix function and MATRIX structure */

typedef struct {
    int element_size;
    unsigned int rows;
    unsigned int cols;
    char **ptr;
               } MATRIX;

    extern "C"  MATRIX *matrix_allocate(int,int,int);
    extern "C"  void matrix_free(MATRIX *);
    extern "C"  void matrix_print(MATRIX *);
    extern "C"  MATRIX *matrix_scale(MATRIX *,double);
    extern "C"  MATRIX *matrix_crop(MATRIX *,int,int,int,int);
    extern "C"  MATRIX *matrix_add(MATRIX *,MATRIX *);
    extern "C"  MATRIX *matrix_sub(MATRIX *,MATRIX *);
    extern "C"  MATRIX *matrix_mult_pwise(MATRIX *,MATRIX *);
    extern "C"  MATRIX *matrix_mult(MATRIX *,MATRIX *);
    extern "C"  MATRIX *matrix_transpose(MATRIX *);
    extern "C"  MATRIX *matrix_invert(MATRIX *);
    extern "C"  double matrix_det(MATRIX *);
    extern "C"  MATRIX *matrix_read(char *);
    extern "C"  MATRIX *matrix_trailer_read(char *,char*);
    extern "C"  DSP_FILE *matrix_write(MATRIX *,char *);

/* image processing routines */
    extern "C"  void dct2d(MATRIX *);
    extern "C"  void idct2d(MATRIX *);
    extern "C"  float *histogram(MATRIX *,int,int);
    extern "C"  MATRIX *convol2d(MATRIX *,MATRIX *);
    extern "C"  MATRIX *nonlin2d(MATRIX *,int,int);
