#include "unify.h"
#include <ctype.h>

int ConstraintListNews = 0;
int ConstraintListDeletes = 0;
int ConstraintNews = 0;
int ConstraintDeletes = 0;


ConstraintList::ConstraintList(int (*cmpf)(Constraint *,Constraint *),
			       char *string,int max) : SortedList<Constraint *>(cmpf) {
  char *p,*q;
  Constraint *c;
  Path *p1=NULL, *p2=NULL;
  int head1, head2, count;
  Dag *d1=NULL;
  char buf[BUFSIZ];
  extern int GrammarFileLineNumber;

  ConstraintListNews++;

  p=string+1;
  while(isspace(*p)) p++;
  // read (path = path)
  while (*p!=')') {
    if (*p!='(') {
      fprintf(stderr,"line %d: read garbage while building ConstraintList.\n\tIgnoring to end of string.\n",GrammarFileLineNumber);
      break;
    }
    p++;
    while(isspace(*p)) p++;

    //read path
    if (sscanf(p,"(%d%n",&head1,&count)!=1) {
      fprintf(stderr,"line %d: read garbage while building ConstraintList.\n\tIgnoring to end of string.\n",GrammarFileLineNumber);
      break;
    } 
    p+=count;
    if(!isspace(*p)) p--;
    *p='(';
    p1=new Path;
    if (!(p=p1->stringread(p))) {
      fprintf(stderr,"line %d: read garbage while building ConstraintList.\n\tIgnoring to end of string.\n",GrammarFileLineNumber);
      delete p1;
      p1=NULL;
      break;
    }
      
    while(isspace(*p)) p++;
    if (*p != '=') {
      fprintf(stderr,"line %d: read garbage (expected =) while building ConstraintList.\n\tIgnoring to end of string.\n",GrammarFileLineNumber);
      delete p1;
      p1=NULL;
      break;
    }
    p++;
    while(isspace(*p)) p++;

    //either read path
    if (sscanf(p,"(%d%n",&head2,&count)==1) {
      p+=count;
      if(!isspace(*p)) p--;
      *p='(';
      p2=new Path;
      if (!(p=p2->stringread(p))) {
      fprintf(stderr,"line %d: read garbage while building ConstraintList.\n\tIgnoring to end of string.\n",GrammarFileLineNumber);
	delete p1;
	p1=NULL;
	delete p2;
	p2=NULL;
	break;
      }
      // or read atom
    } else if (sscanf(p,"%[^) \t]%n",buf,&count)==1) {
      d1=new Dag(buf);
      p2=new Path;
      head2=-1;
      p+=count;
      while (isspace(*p)) p++;
      if (*p!=')') {
      fprintf(stderr,"line %d: read garbage while building ConstraintList.\n\tIgnoring to end of string.\n",GrammarFileLineNumber);
	delete p1;
	p1=NULL;
	delete p2;
	p2=NULL;
	delete d1;
	d1=NULL;
	break;
      }
    } else {
      fprintf(stderr,"line %d: read garbage while building ConstraintList.\n\tIgnoring to end of string.\n",GrammarFileLineNumber);
      delete p1;
      break;
    }

    while(isspace(*p)) p++;
    max = max | 1;
    if (!(max & (1<<head1 | 1<<head2))) { 
      fprintf(stderr,"Buffer: %s\n",string);
      fprintf(stderr,"warning, line %d: constraint identifies non-existent children\n",GrammarFileLineNumber);
    }
    add(new Constraint(head1,head2,p1,p2,d1));
    p1=NULL;
    p2=NULL;
    d1=NULL;
    head1=0;
    head2=0;
    if (*p!=')') { 
      fprintf(stderr,"line %d: read garbage (expected ')') while building ConstraintList.\n\tIgnoring to end of string.\n",GrammarFileLineNumber);
      break;
    }
    p++;
    while(isspace(*p)) p++;
  }
  //internal breaks should land here.
  
}

int Constraint_compare(Constraint *c1, Constraint *c2) {
  return c1->head-c2->head;
}
