/*
 * io.h
 * 
 * Header for input/output routines for the 'ffwd' pure-C forward pass code.
 *
 * 1999nov08 dpwe@icsi.berkeley.edu
 * $Header: /u/drspeech/src/ffwd/RCS/io.h,v 1.1 1999/11/09 05:07:55 dpwe Exp $
 */

int readmlp3(char *fname, int ninp, int nhid, int nout, 
	     float *ihwts, float *howts);
    /* <fname> is the name of an mlp3 ascii wts file of 
       <ninp>:<nhid>:<nout>.  <ihwts> points to a pre-allocated 
       buffer of <nhid> rows of <ninp>+1 cols (bias as last column);
       <howts> points to <nout> rows fo <nhid+1> cols. 
       Return 1 on success, 0 on fail. */

int readnorms(char *fname, int npts, float *bias, float *scale);
int writenorms(char *fname, int npts, float *means, float *sds);

FILE *onlftrs_open_r(char *name);
    /* Open the input online features stream */
void onlftrs_close(FILE *f);

int onlftrs_read(FILE *fp, float *buf, int nftrs);
    /* Read a frame of online features from the input.  
       Normally, return 0.  On error, return -1.  At EOS, return 1. */
FILE *rapbin_open_w(char *name, int width);
    /* Open the named file for rapbin output */
void rapbin_close(FILE *f);

int rapbin_write(FILE *f, float *vals, int nftrs);
    /* Write a frame of output data in rapbin format. */
int rapbin_write_eos(FILE *f);

/*
 * LNA file writing
 */
FILE *lna_open_w(char *name, int width);
    /* Open the named file for lna output */
void lna_close(FILE *f);

int lna_write(FILE *f, float *vals, int nftrs);
    /* Write a frame of output data in lna format. */
int lna_write_eos(FILE *f);
    /* Write EOS mark i.e. set the flag & write the last frame*/

