/*
    $Header: /u/spert/src/fltvec/php/RCS/mulsum_vfvf_f.c,v 1.4 1995/10/13 00:15:46 davidj Exp $

    PHIPAC code for dot-product.
*/

#include <fltv-config.h>
#include <stddef.h>
#include <fltv-defs.h>
#include <fltv-scansrc.h>

#ifdef DECL_php_mulsum_vfvf_f
float php_mulsum_vfvf_f(const size_t n, const float* avec, const float* bvec);
#endif
#ifdef DECL_php_mulsum_vdvd_d
double php_mulsum_vdvd_d(const size_t n, const double* avec,
			 const double* bvec);
#endif

#ifdef DEFN_php_mulsum_vfvf_f
#define FP_TYPE float
#define NAME php_mulsum_vfvf_f
#endif

#ifdef DEFN_php_mulsum_vdvd_d
#define FP_TYPE double
#define NAME php_mulsum_vdvd_d
#endif


FP_TYPE
NAME(const size_t n, const FP_TYPE* avec, const FP_TYPE* bvec)
{
    register FP_TYPE sum0 = 0.0;
    register FP_TYPE sum1 = 0.0;

    const FP_TYPE *all_endp = avec + n;
    const FP_TYPE *smallblock_endp = avec + (n & ~3);
    const FP_TYPE *bigblock_endp = avec + (n & ~15);

    while (avec != bigblock_endp)
    {
        sum0 += avec[0] * bvec[0];
        sum1 += avec[1] * bvec[1];
        sum0 += avec[2] * bvec[2];
        sum1 += avec[3] * bvec[3];
        sum0 += avec[4] * bvec[4];
        sum1 += avec[5] * bvec[5];
        sum0 += avec[6] * bvec[6];
        sum1 += avec[7] * bvec[7];
        sum0 += avec[8] * bvec[8];
        sum1 += avec[9] * bvec[9];
        sum0 += avec[10] * bvec[10];
        sum1 += avec[11] * bvec[11];
        sum0 += avec[12] * bvec[12];
        sum1 += avec[13] * bvec[13];
        sum0 += avec[14] * bvec[14];
        sum1 += avec[15] * bvec[15];

        avec += 16; bvec += 16;
    }

    while (avec != smallblock_endp)
    {
        sum0 += avec[0] * bvec[0];
        sum1 += avec[1] * bvec[1];
        sum0 += avec[2] * bvec[2];
        sum1 += avec[3] * bvec[3];

        avec += 4; bvec += 4;
    }

    sum0 += sum1;

    /* Do trailing portion in naive loop. */
    while (avec != all_endp)
        sum0 += (*avec++) * (*bvec++);

    return sum0;
}
