/*
** $Header: /u/spert/src/fltvec/tor/RCS/milli_vff_vf.S,v 1.2 1995/10/13 03:33:02 davidj Exp $
**
** Routines that use millicode to do op_vff_vf() and op_fvf_vf()
*/

#include "tor/tordef.h"
#include "m_regdef.h"

#define length a0
#define aPtr a1
#define aVal a1
#define bPtr a2
#define bVal a2
#define zPtr a3
#define savedRA t0
#define autoincrement t1
#define done t2
#define maxvlr t3


/*
** Note - the function linkage stuff on page D-23 of Kane and Heinrich is
** confusing.  However, if you pass an integer argument first, all following
** floating point arguments are put in integer registers.  Hence we do not
** have to play around with mfc1/mtc1 stuff here.
*/

#define MILLI_VFF_VF(RTNNAME, MILLINAME) \
	.globl RTNNAME; \
	.ent RTNNAME; \
RTNNAME: \
        .set    noreorder; \
        bgtu    length, MAXVLEN, 1f; \
        ctvu    length, vlr; \
        .set    reorder; \
	lw.v va0,aPtr; \
	mov.vs va1, bVal; \
	move savedRA, ra; \
	jal MILLINAME; \
	sw.v vz0,zPtr; \
	j savedRA; \
\
1: \
	li maxvlr,MAXVLEN; \
	ctvu maxvlr,vlr; \
	li autoincrement,(4*MAXVLEN); \
	lwai.v va0,aPtr,autoincrement; \
	mov.vs va1, bVal; \
	move savedRA, ra; \
2: \
	jal MILLINAME; \
	lwai.v va0,aPtr,autoincrement; \
	mov.vs va1, bVal; \
	subu length, MAXVLEN; \
        sltu done, length, MAXVLEN+1; \
	swai.v vz0,zPtr, autoincrement; \
	beqz done, 2b; \
\
	ctvu length,vlr; \
	jal MILLINAME; \
	sw.v vz0,zPtr; \
	j savedRA; \
	.end RTNNAME

/****************************************************************/ 

#ifdef DECL_tor_add_vff_vf
void tor_add_vff_vf(size_t len, const float* a, float b, float* res);
#endif

#ifdef DEFN_tor_add_vff_vf
MILLI_VFF_VF(tor_add_vff_vf, tor_add_gfgf_gf)
#endif

/****************************************************************/

#ifdef DECL_tor_sub_vff_vf
void tor_sub_vff_vf(size_t len, const float* a, float b, float* res);
#endif

#ifdef DEFN_tor_sub_vff_vf
MILLI_VFF_VF(tor_sub_vff_vf, tor_sub_gfgf_gf)
#endif


/****************************************************************/

#ifdef DECL_tor_mul_vff_vf
void tor_mul_vff_vf(size_t len, const float* a, float b, float* res);
#endif

#ifdef DEFN_tor_mul_vff_vf
MILLI_VFF_VF(tor_mul_vff_vf, tor_mul_gfgf_gf)
#endif


/****************************************************************/

#ifdef DECL_tor_div_vff_vf
void tor_div_vff_vf(size_t len, const float* a, float b, float* res);
#endif

#ifdef DEFN_tor_div_vff_vf
MILLI_VFF_VF(tor_div_vff_vf, tor_div_gfgf_gf)
#endif

/****************************************************************/

#define MILLI_FVF_VF(RTNNAME, MILLINAME) \
	.globl RTNNAME; \
	.ent RTNNAME; \
RTNNAME: \
        .set    noreorder; \
        bgtu    length, MAXVLEN, 1f; \
        ctvu    length, vlr; \
        .set    reorder; \
	lw.v va1,bPtr; \
	mov.vs va0, aVal; \
	move savedRA, ra; \
	jal MILLINAME; \
	sw.v vz0,zPtr; \
	j savedRA; \
\
1: \
	li maxvlr,MAXVLEN; \
	ctvu maxvlr,vlr; \
	li autoincrement,(4*MAXVLEN); \
	lwai.v va1,bPtr,autoincrement; \
	mov.vs va0, aVal; \
	move savedRA, ra; \
2: \
	jal MILLINAME; \
	lwai.v va1,bPtr,autoincrement; \
	mov.vs va0, aVal; \
	subu length, MAXVLEN; \
        sltu done, length, MAXVLEN+1; \
	swai.v vz0,zPtr, autoincrement; \
	beqz done, 2b; \
\
	ctvu length,vlr; \
	jal MILLINAME; \
	sw.v vz0,zPtr; \
	j savedRA; \
	.end RTNNAME

/****************************************************************/

#ifdef DECL_tor_sub_fvf_vf
void tor_sub_fvf_vf(size_t len, float a, const float* b, float* res);
#endif

#ifdef DEFN_tor_sub_fvf_vf
MILLI_FVF_VF(tor_sub_fvf_vf, tor_sub_gfgf_gf)
#endif

/****************************************************************/

#ifdef DECL_tor_div_fvf_vf
void tor_div_fvf_vf(size_t len, float a, const float* b, float* res);
#endif

#ifdef DEFN_tor_div_fvf_vf
MILLI_FVF_VF(tor_div_fvf_vf, tor_div_gfgf_gf)
#endif


