/*
 * soundTkInit.C
 * 
 * Init file for sndwvfm, Tk widget to display waveforms
 *
 * 1998apr17 dpwe@icsi.berkeley.edu after stftSoundInit.C
 * $Header: /n/yam/da/dpwe/src/tcl/sound_otcl/RCS/stftSoundInit.C,v 1.1 1997/08/13 01:42:28 dpwe Exp dpwe $
 */

#include <tcl.h>

extern "C" {
int SndWvfm_Init(Tcl_Interp *interp);
int Sound_tk_Init(Tcl_Interp *interp);
int Sound_tk_SafeInit(Tcl_Interp *interp);
}

/* Initialization commands */
int Sound_tk_Init(Tcl_Interp *interp)
{   /* Package opening call */
    int rc = TCL_OK;
    
    // for Tcl7.5+, signal the package mechanism
    Tcl_PkgProvide(interp, "TkSound", SOUND_VERSION);
    
    if(SndWvfm_Init(interp)==TCL_ERROR) {return TCL_ERROR;}

    return rc;
}

int Sound_tk_SafeInit(Tcl_Interp *interp)
{   /* Package opening call */
    return Sound_tk_Init(interp);
}

