#
# sound_init.tcl
#
# File to setup the Sound tcl package.
# Mainly this just loads the dynamic library, but it also ensures the 
# prerequisite libraries are loaded.
#
# 1997aug13 dpwe@icsi.berkeley.edu
# $Header: /u/drspeech/src/guitools/sound_otcl/RCS/sound_init.tcl,v 1.5 1998/11/26 02:39:05 dpwe Exp $

# We need: otcl farray

# A list of pairs of package names and commands to check for them
set _needed_pkgs {{Otcl otcl} {Farray floatArray}}

# Request the packages
foreach pkg $_needed_pkgs {
    set pkgName [lindex $pkg 0]
    set pkgCmd  [lindex $pkg 1]

    # Find the package through the standard mechanism
    package require $pkgName

    # Make sure that each package is genuinely loaded by executing 
    # the autoload cmd if necessary
    if {[info commands $pkgCmd] == ""} {
	# "package require" just sets up the auto_index.  Make sure we 
	# actually load it.
	eval $auto_index($pkgCmd)
    }
}

# Load our library (includes the "package provide" command 
# and the "otcl clear" command to rebuild the otcl table)
load [file join [file dirname [info script]] libsound_otcl[info sharedlibext]] Sound
