/* $Header: /n/lasagna/db/davidj/spert/src/quicknet/RCS/QN_libc.h,v 1.15 1996/04/27 01:30:07 davidj Exp $
**
** This file contains some C library functions that may not exist on all
** systems
*/

#ifndef QN_libc_h_INCLUDED
#define QN_libc_h_INCLUDED

/* Must include the config.h file first */
#include <QN_config.h>
#include <stdio.h>
#include <stddef.h>
#include <math.h>
#include "intvec.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef QN_HAVE_FSETPOS

typedef long fpos_t;

int fsetpos(FILE* stream, const fpos_t *pos);
int fgetpos(FILE* stream, fpos_t *pos);

#endif

#ifndef SEEK_SET
#define SEEK_SET (0)
#endif

#ifndef QN_HAVE_STRERROR

char* strerror(int errno);

#endif

/* newlib defines log2 as a macro and it is not found by autoconf,
   hence we have to check for the macro definition here */

#if !defined(QN_HAVE_LOG2) && !defined(log2)
#define log2(val) (log(val)/log(2.0))
#endif

extern int errno;

#ifndef MAXPATHLEN
#define MAXPATHLEN (1024)
#endif

#ifndef MAXHOSTNAMELEN
#define MAXHOSTNAMELEN (1024)
#endif

void conv_vi8_vi32(size_t len, const intv_int8_t* from, intv_int32_t* to);
void conv_vi32_vf(size_t len, const intv_int32_t* from, float* to);

#ifdef __cplusplus
}
#endif

#endif
