.de Sh
.br
.ne 5
.PP
\fB\\$1\fR
.PP
..
.de Sp
.if t .sp .5v
.if n .sp
..
.               \" Path Name
.               \"      uses Courier fonts for V4.0
.de PN
.ie t \&\f(CB\\$1\f(NR\\$2
.el \fI\\$1\fP\\$2
..
.		\" The following macros added by dpwe for Ultrix 4..
.               \" Manual section reference
.               \"      uses Courier fonts for V4.0
.de MS
.ie t \&\f(CB\\$1\f(NR(\\$2)\\$3
.el \fI\\$1\fP(\\$2)\\$3
..
.de EX		\" Begin Example
.ie \\n(.$ .nr EX \\$1n
.el \{\
.	ie n .nr EX 0n
.	el .nr EX 0n
.\}
.in +\\n(EXu
.if n .sp 1
.if t .sp .5v
.nf
.CW
.ft CB
..
.de EE		\" End example
.in -\\n(EXu
.fi
.}f             \" restore basic text attributes
.if n .sp 1
.if t .sp .5v
..
.TH WORDSCORE 1 "2001-01-14" dpwe   \" $Header: /n/abbott/da/drspeech/src/wordscore/RCS/wordscore.man,v 1.1 2001/01/14 16:24:46 dpwe Exp $
.SH NAME
wordscore - simple word-error-rate calculation
.SH SYNOPSIS
\fBwordscore
[\-v\fB]
[\-b \fIbegStr\fB]
[\-e \fIendStr\fB]
[\-m \fImidStr\fB]
\-r \fIrefFile\fB
\-w \fIwrdFile\fB
\fR
.SH DESCRIPTION
.PN wordscore
is the old reliable word-error-rate scoring program used for simple 
recognition tests at ICSI.  It takes the wordstrings generated by a 
recognition run over a test set, compares them to the 'ground truth' 
reference wordstrings for that set, and reports the overall word-error-rate, 
and the break-down into substitutions, deletions and insertions.
The comparison is made via dynamic programming to find the lowest-error 
correspondence between the two strings.  
These numbers are reported for the entire test set; in verbose mode, 
they are also calculate for each individual utterance, and the reference 
and recognized wordstrings for each utterance are displayed in an 
aligned fashion, so the actual errors can be seen.
.SH OPTIONS
.P
.PD 0
.B -b \fIbegStr\fR ("**s")
.P
.B -m \fImidStr\fR ("***")
.TP
.PD 1
.B -e \fIendStr\fR ("**e")
Strings that may appear in the recognizer output (for instance, marking 
the beginning and end of each utterance), but which should be ignored 
for the purposes of recognition.  \fIbegStr\fR is supposed to only 
occur at the beginning of a recognized string, \fIendStr\fR at the 
end, and \fImidStr\fR anywhere in the string.
.TP
.PD 0
.B -w \fIwrdFile\fR
.TP
.PD 1
.B -r \fIrefFile\fR
The files containing the recognizer output (-w) and the reference 
ground-truth (-r) wordstrings.  Each line of each 
file relates to the words of a separate corresponding utterance.  If the first 
token in the line begins with a digit ('0'..'9') or a paren ('('), 
it is assumed to be the utterance ID and is ignored.  If the first line 
of a file begins "noway version", it is ignored (as a special case to 
handle results from the 
.MS noway 1
decoder).
.TP
.B -v
Verbose output: print aligned versions of both wordstrings for every 
utterance, and summarize the substitutions, deletions and insertions 
for each utterance.  Without this option, the only output is the 
aggregate error counts and percentages for the whole set.  Outputs 
are always written to standard output.
.SH BUGS
.PN wordscore
doesn't offer any sophisticated features such as allowing alternative 
transcriptions.  For the NIST/DARPA tasks, a far more complex scoring 
procedure is used, based around hubscr03.pl and sclite programs.
.SH HISTORY
The current version is a C++ rewrite of the original C program, which 
was written by Chuck Wooters in 1991 and modified by Andreas Stolcke in 
1994.  The rewrite is due to Hiroaki Ogawa in 1996.
.SH SEE ALSO
.MS sclite 1 ,
.MS noway 1 ,
.SH AUTHORS
Chuck Wooters,
.B wooters@icsi.berkeley.edu ,
Andreas Stolcke, 
.B stolcke@icsi.berkeley.edu , 
Hiroaki Ogawa,
.B ogawah@icsi.berkeley.edu .
Man page by Dan Ellis, 
.B dpwe@icsi.berkeley.edu .
